#ifndef CLIB_SOCKET_INLINES_H
#define CLIB_SOCKET_INLINES_H

/*
 * $Id: socket_inlines.h,v 1.1 1993/07/07 15:23:57 too Exp $
 *
 * Copyright  1993 AmiTCP/IP Group, <amitcp-group@hut.fi>
 *                  Helsinki University of Technology, Finland.
 *                  All rights reserved.
 *
 * Some inlines to replace stubs for compilers that can handle inlines.
 * This file is for AmiTCP/IP bsdsocket.library
 *
 * HISTORY
 * $Log: socket_inlines.h,v $
 * Revision 1.1  1993/07/07  15:23:57  too
 * Initial revision
 *
 */

static __inline LONG
  select(LONG nfds, fd_set *readfds, fd_set *writefds, fd_set *exeptfds,
	 struct timeval *timeout)
{
  /* call WaitSelect with NULL signal mask pointer */
  return WaitSelect(nfds, readfds, writefds, exeptfds, timeout, NULL);
}

static __inline char *
  inet_ntoa(struct in_addr addr) 
{
  return Inet_NtoA(addr.s_addr);
}
static __inline struct in_addr
  inet_makeaddr(int net, int host)
{
  struct in_addr addr;
  addr.s_addr = Inet_MakeAddr(net, host);
  return addr;
}
static __inline unsigned long
  inet_lnaof(struct in_addr addr) 
{
  return Inet_LnaOf(addr.s_addr);
}
static __inline unsigned long
  inet_netof(struct in_addr addr)
{
  return Inet_NetOf(addr.s_addr);
}

#endif /* CLIB_SOCKET_INLINES_H */
