/* $Id: pwd.h,v 1.2 1993/09/15 01:35:12 ppessi Exp $
 *
 * pwd.h - Passwd structure and prototypes for Network Library
 *
 * This file is part of the AmiTCP/IP Network Library.
 *
 * Author: ppessi <Pekka.Pessi@hut.fi>
 * Copyright  1993 AmiTCP/IP Group, <AmiTCP-Group@hut.fi>
 *                  Helsinki University of Technology, Finland.
 *
 * Created      : Sun Jun 20 17:52:37 1993 ppessi
 * Last modified: Wed Sep 15 07:38:35 1993 ppessi
 */

#ifndef PWD_H
#define PWD_H

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

/* Normally defined in <netdb.h> */
#ifndef _PATH_PASSWD
#define _PATH_PASSWD  "AmiTCP:db/passwd"
#endif

/* The passwd structure */
struct passwd
{
  UBYTE *pw_name;		/* Username */
  UBYTE *pw_passwd;		/* Encrypted password */
  ULONG  pw_uid;		/* User ID */
  ULONG  pw_gid;		/* Group ID */
  UBYTE *pw_gecos;		/* Real name etc */
  UBYTE *pw_dir;		/* Home directory */
  UBYTE *pw_shell;		/* Shell */
};

#ifndef _UID_T
#define _UID_T ULONG
typedef _UID_T uid_t;
#endif

/* 
 * POSIX compatible routines 
 */
struct passwd *getpwuid(uid_t uid);
struct passwd *getpwnam(const char *name);

#endif
