/*
 * res_init.c
 *
 * Author: Tomi Ollila <too@cs.hut.fi>
 *
 * 	Copyright (c) 1993 OHT-AmiTCP/IP Group
 * 	      All rights reserved
 *
 * Created: Mon May 10 10:40:20 1993 too
 * Last modified: Thu Jun  3 22:05:33 1993 too
 *
 * $Id: res_init.c,v 1.3 1993/06/03 19:05:48 too Exp $
 *
 * HISTORY
 * $Log: res_init.c,v $
 * Revision 1.3  1993/06/03  19:05:48  too
 * Fixed global res_lock to be zero after compilation (for sure)
 *
 * Revision 1.2  1993/06/02  19:26:17  too
 * Moved resolver stuff here from kern/ -directory
 *
 * Revision 1.1  1993/06/01  16:30:33  too
 * Initial revision
 *
 *
 */

#include <kern/amiga_includes.h>

#include <sys/types.h>
#include <api/resolv.h>

struct state _res;
struct SignalSemaphore res_lock = { 0 };

void
res_init()
{
  _res.retrans = RES_TIMEOUT;
  _res.retry   = 4;
  _res.options = RES_DEFAULT;

  InitSemaphore(&res_lock);
}

