/*  getprofile.h    simple preferences reading for profile information
 *
 * Copyright 1988, Chris Newman
 * All Rights Reserved
 * Permission is granted ot copy, modify, and use this as long
 * as this notice remains intact.  This is a nifty program.
 *
 * $Author: ppessi $ $Revision: 1.3 $ $Date: 1993/07/12 22:59:59 $
 */

extern char ProgName[];	    /* current program name */
extern char PrefFile[];	    /* list of preferences files ('\0' separated) */
extern char CurPrefFile[];  /* preferences file that preference was found in */
extern char LastProfile[];  /* value of last preference read */
extern char LineBuf[];	    /* buffer of line with last preference */

/* This returns a NULL if it fails, and is called by all other routines
 */
char *getprofile(char *preference);

/* This returns dflt, unless on/of, y/n, or 1/0 is at the beginning 
 * of the preference in which case, it returns 0 or 1 as appropriate.
 */
int getprofileswitch(char *preference, int dflt);

/* This returns dflt, unless a positive or negative integer is at the
 * beginning of the preference line.
 */
int getprofileint(char *preference, int dflt);

/* This checks the environment variable env, if that is not found, it
 * checks the preference, and if that is not found it returns dflt
 */
char *getenvprofile(char *preference, char *env, char *dflt);

/* This returns TRUE if the preference exists
 */
int profileentryexists(char *preference);
